function report_account_state(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportAccountStateWidget = reporting.Base.extend({
        template: 'ReportAccountState',
        rowsData :[],
        content :[],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'click-row.bs.table #table' : 'clickAnalysisDetail',
            'change #current-company' : 'updateSelections',
            'change #current-store' : 'updateJournalSelections',
            'change #current-date' : 'ShowDateRange',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new model.eiru_reports.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }
        },

        clickAnalysisDetail: function(e, row, $element,field){
            if (field == 'partner_name'){
                this.do_action({
                    name:"Cliente",
                    type: 'ir.actions.act_window',
                    res_model: "res.partner",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.partner_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.partner_id,
                });
            }

            if (field == 'invoice_name'){
                this.do_action({
                    name:"Factura",
                    type: 'ir.actions.act_window',
                    res_model: "account.invoice",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.invoice_id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.invoice_id,
                });
            }
            e.stopImmediatePropagation();
        },

        fetchInitial: function () {
            var self = this;
            self.fetchResCompany().then(function (ResCompany) {
                return ResCompany;
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
                if(ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                return self.fetchResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                if(ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                return self.fetchAccountJournal();
            }).then(function(AccountJournal){
                self.AccountJournal = AccountJournal;
                if(AccountJournal.length > 0){
                    self.$el.find('#current-journal').append('<option value="9999999">Todos los vendedores</option>');
                    _.each(AccountJournal,function(item){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.journal').css('display','none');
                }
                return self.fetchAccountPeriod();
            }).then(function(AccountPeriod){
                self.AccountPeriod = AccountPeriod;
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' +  item.id + '">' + item.name + '</option>');
                });
                return self.fetchResCurrency();
            }).then(function(ResCurrency){
                self.ResCurrency = ResCurrency;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });

            this.fetchAccountJournal().then(function(AccountJournal) {
                return AccountJournal;
            }).then(function (AccountJournal){
                self.AccountJournal = AccountJournal;
                return self.fetchAccountInvoice();
            }).then(function (AccountInvoice){
                self.AccountInvoice = AccountInvoice;
                return self.BuildTable();
            });
        },

        /*====================================================================
            RES COMPANY
        ====================================================================*/
        fetchResCompany: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('res.company');
            var field=['id','name','currency_id','logo'];
            currency.query(field).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },


        /*====================================================================
            RES STORE
        ====================================================================*/
        fetchResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id','name','company_id'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            ACCOUNT JOURNAL
        ====================================================================*/
        fetchAccountJournal: function(){
            var self = this;
            var journal = self.$el.find('#current-journal').val();
            var domain = [['active','=',true],['type','=','sale']];
            if(journal && journal != 9999999){
                domain.push(['id','=',parseInt(journal)]);
            }
            var AccountJournal = new model.web.Model('account.journal');
            return AccountJournal.call('getAccountJournal',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*=====================================================================
            ACCOUNT PERIOD
        =====================================================================*/
        fetchAccountPeriod: function () {
            var self = this;
            var defer = $.Deferred();
            var domain = [['special','=',false]];
            var field =['id', 'name', 'date_start','date_stop','company_id'];
            var AccountPeriod = new model.web.Model('account.period');
            AccountPeriod.query(field).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES CURRENCY
        ====================================================================*/
        fetchResCurrency : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var ResCurrency = new model.web.Model('res.currency');
            ResCurrency.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            ACCOUNT INVOICE
        ====================================================================*/
        fetchAccountInvoice: function () {
            var self = this;
            var store = self.$el.find('#current-store').val();
            var state = self.$el.find('#current-state').val();
            var period = self.$el.find('#current-period').val();
            var company = self.$el.find('#current-company').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();

            if(store && store != 9999999){
                var journal_ids = _.map(_.filter(self.AccountJournal,function (item) {
                    return item.store_ids == store;
                }), function(map){
                    return map.id;
                });
            }else{
                var journal_ids = _.flatten(_.map(self.AccountJournal, function (item) {
                    return item.id;
                }));
            }

            var domain = [
                ['state','in',['open','paid']],
                ['type', '=', 'out_invoice'],
                ['journal_id','in',journal_ids],
            ];

            if(company && company != 9999999){
                domain.push(['company_id','=',parseInt(company)]);
            }

            if(period && period != 9999999){
                domain.push(['period_id','=',parseInt(period)]);
            }

            if(state && state != 9999999){
                domain.push(['state','=',state]);
            }


            if(date && date != 9999999){

                if(desde){
                    var date = desde.split('/')
                    date = (date[2]+"-"+date[1]+"-"+date[0]);
                    domain.push(['date_invoice','>=',date]);
                }

                if(hasta){
                    var date = hasta.split('/')
                    date = (date[2]+"-"+date[1]+"-"+date[0]);
                    domain.push(['date_invoice','<=',date]);
                }

                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    domain.push(['date_invoice','=',today]);
                }

                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    domain.push(['date_invoice','=',yesterday]);
                }

                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    domain.push(['date_invoice','like',currentMonth]);
                }

                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    domain.push(['date_invoice','like',lastMonth]);
                }
            }

            var AccountInvoice = new model.web.Model('account.invoice');
            return AccountInvoice.call('getAccountInvoiceDental',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateSelections: function () {
            var self = this;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursellers</option>');
                _.each(self.ResStore,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    if(parseFloat(company) == item.company_id[0]){
                        self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursellers</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todas los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateJournalSelections: function () {
            var self = this;
            var store = self.$el.find('#current-store').val();
            if(store != 9999999){
                /*=============================
                    ACCOUNT JOURNAL SELECTION
                =============================*/
                var journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    if(parseFloat(store) == item.store_ids){
                        self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*=============================
                    ACCOUNT JOURNAL SELECTION
                =============================*/
                var journal = self.$el.find('#current-journal').empty();
                self.$el.find('#current-journal').append('<option value="9999999">Todas las facturas</option>');
                _.each(self.AccountJournal,function(item){
                    self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        /*====================================================================
            GET RES COMPANY
        ====================================================================*/
        getResCompany: function (id) {
            var self = this;
            return _.filter(self.ResCompany,function (item) {
                return item.id == id;
            })
        },

        /*====================================================================
            GET RES CURRENCY BASE
        ====================================================================*/
        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            })
        },


        /*====================================================================
            GET ACCOUNT INVOICE
        ====================================================================*/
        getAccountInvoice: function (id) {
          var self = this;
          return _.filter(self.AccountInvoice,function (item) {
            return item.journal_id[0] === id;
          });
        },


        /*====================================================================
            BUILD
        ====================================================================*/
        BuildTable: function(){
          var self = this;
          var data = [];
          var company = $('#current-company').val();

          if(company && company != 9999999){
            var ResCompany = self.getResCompany(company).shift();
            var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
          }else{
            var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
          };

          var AccountJournal = self.AccountJournal;
          _.each(AccountJournal,function(item) {


            var AccountInvoice = self.getAccountInvoice(item.id);
            _.each(AccountInvoice,function(item2) {
              var paid = 0;
              paid = item2.amount_total - item2.residual;

              data.push({

                /*=======================
                      IDS
                    =======================*/

                id: item.id,
                invoice_id: item2.id,
                partner_id: item2.partner_id[0],

                /*=======================
                        DATAS
                    =======================*/
                seller_name: item.name,
                date_invoice: item2.date_invoice,
                invoice_name: item2.number,
                partner_name: item2.partner_id[1],
                residual : accounting.formatMoney(item2.residual,'', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                paid : accounting.formatMoney(paid,'', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                amount : accounting.formatMoney(item2.amount_total,'', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),

                /*=======================
                        VALORES SIN FORMATEAR
                    =======================*/
                total_residual_no_format : item2.residual,
                total_paid_no_format : paid,
                total_amount_no_format : item2.amount_total,

                /*==============================
                      TOTAL FOOTER CONFIGURATION
                  ==============================*/
                decimal_places : CurrencyBase.decimal_places,
                thousands_separator: CurrencyBase.thousands_separator,
                decimal_separator: CurrencyBase.decimal_separator,

              });


          });
        });

          self.content = data;
          self.loadTable(data);
          self.$el.find('.report-form').css('display','block');
          self.$el.find('.search-form').unblock();
          self.$el.find('.report-form').unblock();
        },

        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                ResCompany = self.ResCompany[0];
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }
            var getColumns=[];
            var rows=[];
            var footer=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');


            var total_amount = totalFormatter(row);
            var total_paid = totalPaidFormatter(row);
            var total_residual = totalResidualFormatter(row);

            row.push({
              seller_name: 'Totales',
              amount: total_amount,
              paid: total_paid,
              residual: total_residual,
            })

            if (action === 'pdf') {
                var data = _.map(column, function (val){ return val.field});
                _.each(_.map(column,function(val){
                    return val}), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Estado de cuentas de clientes por vendedores';
                var pdf_type = '';
                var pdf_name = 'estado_de_cuentas_de_clientes_por_vendedor_';
                var pdf_columnStyles =  {
                  seller_name: {columnWidth: 41, halign:'left'},
                  date_invoice: {columnWidth: 17, halign:'center'},
                  invoice_name: {columnWidth: 24, halign:'center'},
                  partner_name: {columnWidth: 41, halign:'left'},
                  residual : {columnWidth: 24, halign:'right'},
                  paid : {columnWidth: 24, halign:'right'},
                  amount : {columnWidth: 24, halign:'right'},

                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter = self.getFilter();
                var pdf = new model.eiru_reports.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter
                );
            }
        },
        getFilter: function(){
          var self = this;
          var company = self.$el.find('#current-company').val();
          var store = self.$el.find('#current-store').val();
          var journal = self.$el.find('#current-journal').val();
          var state = self.$el.find('#current-state').val();
          var period = self.$el.find('#current-period').val();
          var date = self.$el.find('#current-date').val();
          var desde = self.$el.find('#from').val();
          var hasta = self.$el.find('#to').val();

          var filter = [];

          if(company && company){
            var ResCompany = _.filter(self.ResCompany, function(item){
              return item.id == company;
            });
            filter.push({
              title:'Empresa',
              value: ResCompany[0].name,
            });
          }

          if(store && store != 9999999){
            var ResStore =  _.filter(self.ResStore,function (item) {
                return item.id == store;
            });

            filter.push({
                title: 'Sucursal',
                value:  ResStore[0].name,
            });

          }

          if(journal && journal != 9999999){
            var AccountJournal =  _.filter(self.AccountJournal,function (item) {
                return item.id == journal;
            });
            filter.push({
                 title: 'Vendedor',
                 value: AccountJournal[0].name,
               });
          }

          if(state && state != 9999999){
            filter.push({
                title: 'Estado',
                value:  $("#current-state option:selected").text(),
            });
          }

          if(period && period != 9999999){

            var AccountPeriod =  _.filter(self.AccountPeriod,function (item) {
                return item.id == period;
            });
            filter.push({
                 title: 'Periodo',
                 value:  AccountPeriod[0].name,
               });
          }

          if(date && date != 9999999){
            moment.locale('es', {
              months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
            });

            if(date == 'range'){
              filter.push({
                  title: 'Fecha',
                  value:  desde +' al '+hasta,
              });

            }
            else {
              if(date == 'today'){
                  var fecha = moment().format('DD/MM/YYYY');
              }

              if(date == 'yesterday'){
                  var fecha = moment().add(-1,'days').format('DD/MM/YYYY');
              }
              if(date == 'currentMonth'){
                  var fecha = moment().format('MMMM/YYYY');
              }
              if(date == 'lastMonth'){
                  var fecha = moment().add(-1,'months').format('MMMM/YYYY');
              }

              filter.push({
                  title: 'Fecha',
                  value:  fecha,
              });
            }
          }
          return filter;
        },
});
}
