function report_expenses_dental(reporting){
    "use strict";

    var model = openerp;

    reporting.ReportExpensesDentalWidget = reporting.Base.extend({
        template: 'ReportExpensesDental',
        rowsData :[],
        content :[],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            'click #generate' : 'fetchGenerate',
            'click-row.bs.table #table' : 'clickAnalysisDetail',
            'change #current-company' : 'updateSelections',
            'change #current-store' : 'updateStoreSelections',
            'change #current-date' : 'ShowDateRange',
            'change #current-period' : 'updatePeriodSelections',
        },

        init : function(parent){
            this._super(parent);
        },

        start: function () {
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            var date = new model.eiru_reports.ReportDatePickerWidget(self);
            date.fecthFecha();
            this.fetchInitial();
        },

        valorNull:function(dato){
            var valor = "";
            if (dato){
                valor = dato;
            }
            return valor;
        },

        ShowDateRange : function(){
            var self = this;
            var date = self.$el.find('#current-date').val();
            if(date == 'range'){
                self.$el.find('.datepicker').css('display','block');
            }
            if(date != 'range'){
                self.$el.find('.datepicker').css('display','none');
            }

        },

        clickAnalysisDetail: function(e, row, $element,field){
            if (field == 'supplier_invoice_number' || field == 'number'){
                this.do_action({
                    name:"Factura",
                    type: 'ir.actions.act_window',
                    res_model: "account.invoice",
                    views: [[false,'form']],
                    target: 'new',
                    domain: [['id','=', row.id]],
                    context: {},
                    flags: {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id: row.id,
                });
            }
            e.stopImmediatePropagation();
        },

        fetchInitial: function () {
            var self = this;
            this.fetchResPartner().then(function(ResPartner) {
                return ResPartner;
            }).then(function (ResPartner) {
                self.ResPartner = ResPartner;
                if(ResPartner.length > 1){
                    self.$el.find('#current-partner').append('<option value="9999999">Todos los gastos</option>');
                    _.each(ResPartner,function(item){
                        self.$el.find('#current-partner').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.partner').css('display','none');
                }
                return self.fetchResCompany();
            }).then(function(ResCompany){
                self.ResCompany = ResCompany;
                if(ResCompany.length > 1){
                    self.$el.find('#current-company').append('<option value="9999999">Todas las empresas</option>');
                    _.each(ResCompany,function(item){
                        self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.company').css('display','none');
                }
                return self.fetchResStore();
            }).then(function(ResStore){
                self.ResStore = ResStore;
                if(ResStore.length > 1){
                    self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                    _.each(ResStore,function(item){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    });
                }else{
                    self.$el.find('.store').css('display','none');
                }
                return self.fetchAccountPeriod();
            }).then(function(AccountPeriod){
                self.AccountPeriod = AccountPeriod;
                self.$el.find('#current-period').append('<option value="9999999">Todos los periodos</option>');
                _.each(AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.fetchResCurrency();
            }).then(function(ResCurrency){
                self.ResCurrency = ResCurrency;
            });
            self.$el.find('#generate').css('display','inline');
            return;
        },

        fetchGenerate: function () {
            var self = this;
            self.$el.find('.search-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            self.$el.find('.report-form').block({
                message: null,
                overlayCSS: {
                    backgroundColor: '#FAFAFA'
                }
            });
            this.fetchAccountInvoice().then(function(AccountInvoice) {
                return AccountInvoice;
            }).then(function (AccountInvoice){
                self.AccountInvoice = AccountInvoice;
                return self.BuildTable();
            });
        },

        /*=====================================================================
            RES PARTNER
        =====================================================================*/
        fetchResPartner: function() {
            var self = this;
            var domain = [['active', '=', true],['supplier','=',true]];
            var ResPartner = new model.web.Model('res.partner');
            return ResPartner.call('getResPartner',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*=====================================================================
            ACCOUNT PERIOD
        =====================================================================*/
        fetchAccountPeriod: function () {
            var self = this;
            var defer = $.Deferred();
            var domain = [['special','=',false]];
            var fields =['id', 'name', 'date_start','date_stop','company_id'];
            var AccountPeriod = new model.web.Model('account.period');
            AccountPeriod.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES STORE
        ====================================================================*/
        fetchResStore: function(){
            var self = this;
            var defer = $.Deferred();
            var field = ['id','name','company_id'];
            var ResStore = new model.web.Model('res.store');
            ResStore.query(field).all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },


        /*====================================================================
            ACCOUNT INVOICE
        ====================================================================*/
        fetchAccountInvoice: function () {
            var self = this;
            var defer = $.Deferred();
            var period = self.$el.find('#current-period').val();
            var partner = self.$el.find('#current-partner').val();
            var date = self.$el.find('#current-date').val();
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var domain = [
                ['state', 'in',['open','paid']],
                ['type', '=', 'in_invoice'],
                ['origin', '=', null],
            ];
            if(period != 9999999){
                domain.push(['period_id','=',parseInt(period)]);
            }
            if(partner && partner != 9999999){
                domain.push(['partner_id','=',parseInt(partner)]);
            }

            if(date && date != 9999999){

                if(desde){
                    var date = desde.split('/')
                    date = (date[2]+"-"+date[1]+"-"+date[0]);
                    domain.push(['date_invoice','>=',date]);
                }

                if(hasta){
                    var date = hasta.split('/')
                    date = (date[2]+"-"+date[1]+"-"+date[0]);
                    domain.push(['date_invoice','<=',date]);
                }

                if(date == 'today'){
                    var today = moment().format('YYYY-MM-DD');
                    domain.push(['date_invoice','=',today]);
                }

                if(date == 'yesterday'){
                    var yesterday = moment().add(-1,'days').format('YYYY-MM-DD');
                    domain.push(['date_invoice','=',yesterday]);
                }

                if(date == 'currentMonth'){
                    var currentMonth = moment().format('YYYY-MM');
                    domain.push(['date_invoice','like',currentMonth]);
                }

                if(date == 'lastMonth'){
                    var lastMonth = moment().add(-1,'months').format('YYYY-MM');
                    domain.push(['date_invoice','like',lastMonth]);
                }
            }
            var AccountInvoice = new model.web.Model('account.invoice');
            return AccountInvoice.call('getAccountInvoiceDental',[domain], {
                context: new model.web.CompoundContext()
            });
        },

        /*====================================================================
            RES COMPANY
        ====================================================================*/
        fetchResCompany: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new model.web.Model('res.company');
            var field=['id','name','currency_id','logo'];
            currency.query(field).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            RES CURRENCY
        ====================================================================*/
        fetchResCurrency : function(){
            var self = this;
            var defer = $.Deferred();
            var fields = ['id','name', 'symbol', 'rate_silent', 'base', 'decimal_separator', 'decimal_places', 'thousands_separator', 'symbol_position'];
            var domain = [['active', '=', true]];
            var ResCurrency = new model.web.Model('res.currency');
            ResCurrency.query(fields).filter(domain).all().then(function(results) {
                defer.resolve(results);
            });
            return defer;
        },

        /*====================================================================
            UPDATE SELECTIONS
        ====================================================================*/
        updateSelections: function () {
            var self = this;
            var company = self.$el.find('#current-company').val();
            if(company != 9999999){
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    if(parseInt(company) == item.company_id[0]){
                        self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todas los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    if(parseInt(company) == item.company_id[0]){
                        self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
                /*====================
                    PARTNER SELECTION
                ====================*/
                var partner = self.$el.find('#current-partner').empty();
                self.$el.find('#current-partner').append('<option value="9999999">Todas los gastos</option>');
                _.each(self.ResPartner,function(item){
                    if(parseInt(company) == item.company_id[0]){
                        self.$el.find('#current-partner').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*===================
                    STORE SELECTION
                ===================*/
                var store = self.$el.find('#current-store').empty();
                self.$el.find('#current-store').append('<option value="9999999">Todas las sucursales</option>');
                _.each(self.ResStore,function(item){
                    self.$el.find('#current-store').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                /*====================
                    PERIOD SELECTION
                ====================*/
                var period = self.$el.find('#current-period').empty();
                self.$el.find('#current-period').append('<option value="9999999">Todas los periodos</option>');
                _.each(self.AccountPeriod,function(item){
                    self.$el.find('#current-period').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                /*====================
                    PARTNER SELECTION
                ====================*/
                var partner = self.$el.find('#current-partner').empty();
                self.$el.find('#current-partner').append('<option value="9999999">Todas los gastos</option>');
                _.each(self.ResPartner,function(item){
                    self.$el.find('#current-partner').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updateStoreSelections: function () {
            var self = this;
            var store = self.$el.find('#current-store').val();
            if(store != 9999999){
                /*====================
                    PARTNER SELECTION
                ====================*/
                var partner = self.$el.find('#current-partner').empty();
                self.$el.find('#current-partner').append('<option value="9999999">Todas los gastos</option>');
                _.each(self.ResPartner,function(item){
                    if(parseInt(store) == item.store_id[0]){
                        self.$el.find('#current-partner').append('<option value="' + item.id + '">' + item.name + '</option>');
                    }
                });
            }else{
                /*====================
                    PARTNER SELECTION
                ====================*/
                var partner = self.$el.find('#current-partner').empty();
                self.$el.find('#current-partner').append('<option value="9999999">Todas los gastos</option>');
                _.each(self.ResPartner,function(item){
                    self.$el.find('#current-partner').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
            }
        },

        updatePeriodSelections: function () {
            var self = this;
            var period = self.$el.find('#current-period').val();
            if(period != 9999999){
                self.$el.find('#current-date').val(9999999);
                self.$el.find('#current-date').prop('disabled','disabled');
                self.$el.find('.datepicker').css('display','none');
            }else{
                self.$el.find('#current-date').prop('disabled',false);
            }
        },

        /*====================================================================
            GET RES COMPANY
        ====================================================================*/
        getResCompany: function (id) {
            var self = this;
            return _.filter(self.ResCompany,function (item) {
                return item.id == id;
            })
        },

        /*====================================================================
            GET RES CURRENCY BASE
        ====================================================================*/
        getResCurrency: function (id) {
            var self = this;
            return _.filter(self.ResCurrency,function (item) {
                return item.id === id;
            })
        },

        /*============================
            ACCOUNT DATA BY MONTH
        ============================*/
        getContent:function(mes) {
            var self = this;
            return _.flatten(_.filter(self.content,function (inv) {
                return moment(inv.date).format('YYYY-MM') === moment(mes).format('YYYY-MM');
            }));
        },

        /*====================================================================
            BUILD
        ====================================================================*/
        BuildTable: function(){
            var self = this;
            var data = [];
            var AccountInvoice = self.AccountInvoice;
            var company = $('#current-company').val();
            if(company && company != 9999999){
                var ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }
            _.each(AccountInvoice, function(item){

                data.push({
                    id : item.id,
                    reference : self.valorNull(item.reference),
                    number : item.number,
                    date_invoice : moment(item.date_invoice).format('DD/MM/YYYY'),
                    partner_id : item.partner_id[1],
                    amount_untaxed_total : accounting.formatMoney(item.amount_untaxed_currency, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    amount_tax_total : accounting.formatMoney(item.amount_tax_currency, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    amount_total : accounting.formatMoney(item.amount_total_currency, '', CurrencyBase.decimal_places, CurrencyBase.thousands_separator, CurrencyBase.decimal_separator),
                    /*
                    ============================
                        VALORES SIN FORMATAR
                    ============================
                    */

                    amount_untaxed : item.amount_untaxed_currency,
                    amount_tax : item.amount_tax_currency,
                    amount : item.amount_total_currency,
                    /*==============================
                        TOTAL FOOTER CONFIGURATION
                    ==============================*/
                    decimal_places : CurrencyBase.decimal_places,
                    thousands_separator: CurrencyBase.thousands_separator,
                    decimal_separator: CurrencyBase.decimal_separator,
                });
            });
            self.content = data;
            self.loadTable(data);
            self.$el.find('.report-form').css('display','block');
            self.$el.find('.search-form').unblock();
            self.$el.find('.report-form').unblock();


        },



        /*====================================================================
            LOAD BOOTSTRAP TABLE
        ====================================================================*/
        loadTable:function(rowsTable){
            var self = this;
            self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load', rowsTable);
        },

        /*====================================================================
            PRINT PDF
        ====================================================================*/
        clickOnAction: function (e) {
            var self = this;
            var ResCompany;
            var action = this.$el.find(e.target).val();
            var company = $('#current-company').val();
            if(company && company != 9999999){
                ResCompany = self.getResCompany(company).shift();
                var CurrencyBase = self.getResCurrency(ResCompany.currency_id[0]).shift();
            }else{
                ResCompany = self.ResCompany[0];
                var CurrencyBase = self.getResCurrency(self.ResCompany[0].currency_id[0]).shift();
            }
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var column = table.bootstrapTable('getVisibleColumns');
            var row = table.bootstrapTable('getData');


            var amount_untaxed = totalUntaxedFormatter(row);
            var amount_tax = totalTaxFormatter(row);
            var total = totalFormatter(row);

            row.push({
                partner_id : 'Totales',
                amount_untaxed_total : amount_untaxed,
                amount_tax_total : amount_tax,
                amount_total : total,
            });
            if (action === 'pdf') {
                var data = _.map(column, function (val){ return val.field});
                _.each(_.map(column,function(val){
                    return val}), function(item){
                    getColumns.push([{
                        title: item.title,
                        dataKey: item.field
                    }]);
                });
                /*
                ============================================================
                    CONFIGURACION DEL PDF
                ============================================================
                */
                var pdf_title = 'Gastos.';
                var pdf_type = '';
                var pdf_name = 'gastos_';
                var pdf_columnStyles = {
                    reference :{halign:'left'},
                    number : {halign:'left'},
                    date_invoice : {halign:'left'},
                    partner_id : {halign:'left'},
                    amount_untaxed_total : {columnWidth: 30, halign:'right'},
                    amount_tax_total : {columnWidth: 30, halign:'right'},
                    amount_total : {columnWidth: 30, halign:'right'},
                };
                /*
                ============================================================
                    LLAMAR FUNCION DE IMPRESION
                ============================================================
                */
                var filter = self.getFilter();
                var pdf = new model.eiru_reports.ReportPdfWidget(self);
                pdf.drawPDF(
                    _.flatten(getColumns),
                    row,
                    ResCompany,
                    pdf_title,
                    pdf_type,
                    pdf_name,
                    pdf_columnStyles,
                    filter,
                );
            }
        },
        getFilter: function(){
          var self = this;
          var company = self.$el.find('#current-company').val();
          var store = self.$el.find('#current-store').val();
          var partner = self.$el.find('#current-partner').val();
          var period = self.$el.find('#current-period').val();
          var date = self.$el.find('#current-date').val();
          var desde = self.$el.find('#from').val();
          var hasta = self.$el.find('#to').val();

          var filter = [];

          if(company && company){
            var ResCompany = _.filter(self.ResCompany, function(item){
              return item.id == company;
            });
            filter.push({
              title:'Empresa',
              value: ResCompany[0].name,
            });
          }

          if(store && store != 9999999){
            var ResStore =  _.filter(self.ResStore,function (item) {
                return item.id == store;
            });

            filter.push({
                title: 'Sucursal',
                value:  ResStore[0].name,
            });

          }
          if(partner && partner != 9999999){
            var ResPartner = _.filter(self.ResPartner, function(item){
              return item.id == partner;
            })
            filter.push({
                title: 'Gastos',
                value:  ResPartner[0].name,
            });
          }

          if(period && period != 9999999){

            var AccountPeriod =  _.filter(self.AccountPeriod,function (item) {
                return item.id == period;
            });
            filter.push({
                 title: 'Periodo',
                 value:  AccountPeriod[0].name,
               });
          }

          if(date && date != 9999999){
            moment.locale('es', {
              months: 'Enero_Febrero_Marzo_Abril_Mayo_Junio_Julio_Agosto_Septiembre_Octubre_Noviembre_Diciembre'.split('_'),
            });

            if(date == 'range'){
              filter.push({
                  title: 'Fecha',
                  value:  desde +' al '+hasta,
              });

            }
            else {
              if(date == 'today'){
                  var fecha = moment().format('DD/MM/YYYY');
              }

              if(date == 'yesterday'){
                  var fecha = moment().add(-1,'days').format('DD/MM/YYYY');
              }
              if(date == 'currentMonth'){
                  var fecha = moment().format('MMMM/YYYY');
              }
              if(date == 'lastMonth'){
                  var fecha = moment().add(-1,'months').format('MMMM/YYYY');
              }

              filter.push({
                  title: 'Fecha',
                  value:  fecha,
              });
            }
          }
          return filter;
        },
    });
}
